import json 
import numpy as np
import time
import Adafruit_PCA9685
import math
from BNO055 import *

pwn = Adafruit_PCA9685.PCA9685()

tibia_min = 260 #325 according to json file 
tibia_max = 375 #425
chassis_min = 225 #275
chassis_max = 425 #475

pwn.set_pwm_freq(60)	#Sets frequency to 60 Hz

#Pulls Min and Max values for femurs and tibias from the json file
def pullMotorVal():
	json_data = open('/home/pi/Desktop/SpyndraSpy/project/Spyndra_Control/Spyndra_newCode/servo_settings.json').read()
	parsed_json = json.loads(json_data)
	tibia_min = parsed_json['analog tibia min']
	tibia_max = parsed_json['analog tibia max']
	chassis_min = parsed_json['analog chassis min']
	chassis_max = parsed_json['analog chassis max']

#Outputs the motor signals to the motors from the splinegen arrays
#def outputMotor(chassisOutput, tibiaOutput, chassisNum, tibiaNum):
def outputMotor(chassisOutput, tibiaOutput, chassisNum, tibiaNum):
	pwn.set_pwm(chassisNum, 0, int(chassisOutput))
	pwn.set_pwm(tibiaNum, 0, int(tibiaOutput))
 			


def flatIMUdata(bno):
    flatCounter = 0
    nDataPoints = 10
    matrixData = np.zeros(shape=(nDataPoints,2,3))
        
    while flatCounter <nDataPoints:
        currentVectors = produceVector(bno)
        matrixData[flatCounter,0:2,0:3] = currentVectors
        flatCounter= flatCounter+1
                
    return numpy.median(matrixData,axis=0), matrixData

def produceVector(bno):
    rPlace = 1000
    matrixData = np.zeros(shape=(2,3))
    testCounter = 1

    grav = bno.getVector(BNO055.VECTOR_GRAVITY)
    euler = bno.getVector(BNO055.VECTOR_EULER)

    grav_r = (math.ceil(grav[0]*rPlace)/rPlace,math.ceil(grav[1]*rPlace)/rPlace,math.ceil(grav[2]*rPlace)/rPlace)
    euler_rounded = (math.ceil(euler[0]*rPlace)/rPlace,math.ceil(euler[1]*rPlace)/rPlace, math.ceil(euler[2]*rPlace)/rPlace)


    #print euler_rounded
    #print grav_r
    
    matrixData[0,0:3] = euler_rounded
    matrixData[1,0:3] = grav_r

	if ((euler_rounded[0] > 370) or (euler_rounded[1]>370) or (euler_rounded[2]>370)):
		return produceVector(bno)

	if (euler_rounded[0]>180):
		matrixData[0][0] = abs(euler_rounded[0]-360)

        return matrixData



bno = BNO055()
if bno.begin() is not True:
        print "Error initializing IMU"
        exit()
time.sleep(1)
bno.setExternalCrystalUse(True)


flat, flatmatrix = flatIMUdata(bno)
print flat 
for point in flatmatrix:
	print point
